<?php
namespace Ep\Gath\Plugin\Order;

use Ep\Wp\Plugin\PluginInterface;
use WC_Order;

final class ProductType implements PluginInterface
{
    public function __invoke(): void
    {
        add_action('woocommerce_checkout_order_processed', [$this, 'wc_checkout_order_processed'], 10, 3);

        if (defined('WP_ADMIN')) {
            add_filter('woocommerce_hidden_order_itemmeta', [$this, 'wc_hidden_order_itemmeta']);
        }
    }

    public function wc_checkout_order_processed($order_id, /** @noinspection PhpUnusedParameterInspection */ $posted_data, WC_Order $order)
    {
        foreach ($order->get_items() as $item) {
            $product_id = absint(wc_get_order_item_meta($item->get_id(), '_variation_id', true));

            if (0 === $product_id) {
                $product_id = absint(wc_get_order_item_meta($item->get_id(), '_product_id', true));
            }

            if (0 === $product_id) {
                return;
            }

            $type = apply_filters('woocommerce_product_type_query', false, $product_id);
            wc_update_order_item_meta($item->get_id(), '_product_type', $type);
        }
    }

    public function wc_hidden_order_itemmeta(array $meta_keys)
    {
        $meta_keys[] = '_product_type';

        return $meta_keys;
    }
}