<?php
namespace EpTest\Gath;

use Ep\Gath\Gath;
use PHPUnit\Framework\TestCase;

/**
 * Testovi za RESTService.exe
 *
 * @package EpTest\Gath
 * @author Elektronika Perhoč <web@ep.hr>
 * @link http://gitlab.ep.local/ep-framework/gath
 */
class RestServiceTest
{
    use IntegrationTestTrait;

    /**
     * @see http://gitlab.ep.local/gath/rest-service/issues/3
     */
    public function testProductsByCategoryPaginationWorks()
    {
        $container = $this->createContainer([
            'gath' => [
                'base_uri' => 'http://192.168.56.20:57032/'
            ],
        ]);

        /** @var Gath $gath */
        $gath = $container->get('gath');

        $products = $gath->getProductsByCategory(34, 1, 1, 0);
        $productId = $products['Results'][0]['id'];

        $nextPage = $gath->getProductsByCategory(34, 1, 1, 1);

        $this->assertNotEquals($productId, $nextPage['Results'][0]['id']);
    }

    /**
     * @see http://gitlab.ep.local/gath/rest-service/issues/2
     */
    public function testCategoryCanBeSortedWhenContainingGroupedProducts()
    {
        $container = $this->createContainer([
            'gath' => [
                'base_uri' => 'http://192.168.56.20:57032/'
            ],
        ]);

        /** @var Gath $gath */
        $gath = $container->get('gath');

        $result = $gath->getProductsByCategory(33, Gath::SORT_PRICE_ASC);

        $this->assertInternalType('array', $result);
    }
}